////////////////////////////////////////////////////////////////////////////////
///////   Copyright 1992, Silicon Graphics, Inc.  All Rights Reserved.   ///////
//                                                                            //
// This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;     //
// the contents of this file may not be disclosed to third parties, copied    //
// or duplicated in any form, in whole or in part, without the prior written  //
// permission of Silicon Graphics, Inc.                                       //
//                                                                            //
// RESTRICTED RIGHTS LEGEND:                                                  //
// Use,duplication or disclosure by the Government is subject to restrictions //
// as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data     //
// and Computer Software clause at DFARS 252.227-7013, and/or in similar or   //
// successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -    //
// rights reserved under the Copyright Laws of the United States.             //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#ifndef VKSUBMENU_H
#define VKSUBMENU_H

#include <Vk/VkMenu.h>
#include <Vk/VkApp.h>

class VkSubMenu: public VkMenu {

    friend class VkMenuItem;

  public:
    
    VkSubMenu(const char *name, 
	      VkMenuDesc *desc = NULL, 
	      XtPointer defaultClientData = NULL);

    VkSubMenu(Widget parent,
	      const char *, 
	      VkMenuDesc *desc = NULL, 
	      XtPointer defaultClientData = NULL);

    virtual ~VkSubMenu();    

    void showTearOff(Boolean showit);
    virtual  VkMenuItemType menuType ();
    Widget  pulldown() { return _pulldown; }
    virtual const char* className();

   protected:

    Widget _pulldown;
    virtual Widget menuParent();

    virtual void widgetDestroyed();
    virtual void build(Widget);
    XtWorkProcId  _workProcId;

    int _showTearOff;

    void removeWorkProc();

  private:

    static  Boolean buildCallback(XtPointer);
};


#endif
